/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */

import { css } from '@emotion/react';
import { logicalCSS } from '../../global_styling';
import { highContrastModeStyles } from '../../global_styling/functions/high_contrast';
export var euiFlyoutFooterStyles = function euiFlyoutFooterStyles(euiThemeContext) {
  var euiTheme = euiThemeContext.euiTheme;
  return {
    euiFlyoutFooter: /*#__PURE__*/css("background-color:", euiTheme.components.flyoutFooterBackground, ";flex-grow:0;", highContrastModeStyles(euiThemeContext, {
      preferred: logicalCSS('border-top', euiTheme.border.thin)
    }), ";;label:euiFlyoutFooter;")
  };
};